diff --git a/tests/Feature/Http/Controllers/Api/Profile/SessionsControllerTest.php b/tests/Feature/Http/Controllers/Api/Profile/SessionsControllerTest.php
new file mode 100644
index 0000000..e54912d
--- /dev/null
+++ b/tests/Feature/Http/Controllers/Api/Profile/SessionsControllerTest.php
@@ -0,0 +1,69 @@
+<?php
+
+namespace Tests\Feature\Http\Controllers\Api\Profile;
+
+use Tests\Feature\ApiTestCase;
+use Portal\Transformers\SessionTransformer;
+use Portal\User;
+
+class SessionsControllerTest extends ApiTestCase
+{
+    public function test_get_user_sessions_unauthenticated()
+    {
+        $this->getJson('/api/me/sessions')
+            ->assertResponseStatus(401);
+    }
+
+    public function test_get_sessions_if_non_database_driver_is_used()
+    {
+        putenv('SESSION_DRIVER=array');
+
+        $this->refreshApp();
+
+        $this->login();
+
+        $this->getJson('/api/me/sessions')
+            ->assertResponseStatus(404);
+    }
+
+    public function test_get_user_sessions()
+    {
+        putenv('SESSION_DRIVER=database');
+
+        $this->refreshApp();
+
+        $user = $this->login();
+
+        $sessions = $this->generateNonExpiredSessions($user);
+
+        $this->getJson('/api/me/sessions')
+            ->seeStatusCode(200)
+            ->seeJson(
+                $this->transformCollection(collect($sessions), new SessionTransformer)
+            );
+    }
+
+    private function generateNonExpiredSessions(User $user, $count = 5)
+    {
+        $sessions = [];
+        $faker = $this->app->make(\Faker\Generator::class);
+        $lifetime = config('session.lifetime') - 1;
+
+        for ($i = 0; $i < $count; $i++) {
+            array_push($sessions, [
+                'id' => str_random(40),
+                'user_id' => $user->id,
+                'ip_address' => $faker->ipv4,
+                'user_agent' => $faker->userAgent,
+                'payload' => str_random(),
+                'last_activity' => $faker->dateTimeBetween("-{$lifetime} minutes")->getTimestamp()
+            ]);
+        }
+
+        \DB::table('sessions')->insert($sessions);
+
+        return \DB::table('sessions')
+            ->where('user_id', $user->id)
+            ->get();
+    }
+}
diff --git a/tests/Feature/Http/Controllers/Api/Profile/TwoFactorControllerTest.php b/tests/Feature/Http/Controllers/Api/Profile/TwoFactorControllerTest.php
new file mode 100644
index 0000000..f87a6ab
--- /dev/null
+++ b/tests/Feature/Http/Controllers/Api/Profile/TwoFactorControllerTest.php
@@ -0,0 +1,108 @@
+<?php
+
+namespace Tests\Feature\Http\Controllers\Api\Profile;
+
+use Authy;
+use Settings;
+use Tests\Feature\ApiTestCase;
+use Portal\Transformers\UserTransformer;
+use Portal\User;
+
+class TwoFactorControllerTest extends ApiTestCase
+{
+    public function test_update_2fa_unathenticated()
+    {
+        $user = factory(User::class)->create();
+
+        $this->putJson("api/me/2fa")
+            ->assertResponseStatus(401);
+    }
+
+    public function test_enable_two_factor_auth()
+    {
+        $user = $this->login();
+
+        Settings::set('2fa.enabled', true);
+
+        Authy::shouldReceive('isEnabled')->andReturn(false);
+        Authy::shouldReceive('register')->andReturnNull();
+
+        $data = ['country_code' => '1', 'phone_number' => '123'];
+ 
+        $this->putJson("api/me/2fa", $data);
+
+        $transformer = new UserTransformer;
+        $updatedUser = $transformer->transform($user->fresh());
+
+        $this->assertResponseOk()
+            ->seeInDatabase('users', [
+                'id' => $user->id,
+                'two_factor_country_code' => $data['country_code'],
+                'two_factor_phone' => $data['phone_number']
+            ])
+            ->seeJsonContains($updatedUser);
+    }
+
+    public function test_enable_two_factor_auth_when_it_is_already_enabled()
+    {
+        $user = $this->login();
+
+        $this->addPermissionForUser($user, 'users.manage');
+
+        Settings::set('2fa.enabled', true);
+
+        Authy::shouldReceive('isEnabled')->andReturn(true);
+
+        $data = ['country_code' => '1', 'phone_number' => '123'];
+
+        $this->putJson("api/me/2fa", $data);
+
+        $this->assertResponseStatus(422)
+            ->seeJsonContains([
+                'error' => '2FA is already enabled for this user.'
+            ]);
+    }
+
+    public function test_disable_two_factor_auth()
+    {
+        $user = factory(User::class)->create([
+            'two_factor_country_code' => '1',
+            'two_factor_phone' => '123'
+        ]);
+
+        $this->addPermissionForUser($user, 'users.manage');
+
+        $this->be($user, 'api');
+
+        Settings::set('2fa.enabled', true);
+
+        Authy::shouldReceive('isEnabled')->andReturn(true);
+        Authy::shouldReceive('delete')->andReturnNull();
+
+        $this->deleteJson("api/me/2fa");
+
+        $transformer = new UserTransformer;
+        $user = $transformer->transform($user->fresh());
+
+        $this->assertResponseOk()
+            ->seeJsonContains($user);
+    }
+
+    public function test_disable_2fa_when_it_is_already_disabled()
+    {
+        $user = $this->login();
+
+        $this->addPermissionForUser($user, 'users.manage');
+
+        Settings::set('2fa.enabled', true);
+
+        Authy::shouldReceive('isEnabled')->andReturn(false);
+
+        $this->deleteJson("api/me/2fa");
+
+        $this->assertResponseStatus(422)
+            ->seeJsonContains([
+                'error' => '2FA is not enabled for this user.'
+            ]);
+    }
+}
diff --git a/tests/Feature/Http/Controllers/Api/SessionsControllerTest.php b/tests/Feature/Http/Controllers/Api/SessionsControllerTest.php
new file mode 100644
index 0000000..b418490
--- /dev/null
+++ b/tests/Feature/Http/Controllers/Api/SessionsControllerTest.php
@@ -0,0 +1,113 @@
+<?php
+
+namespace Tests\Feature\Http\Controllers\Api;
+
+use Carbon\Carbon;
+use Tests\Feature\ApiTestCase;
+use Tests\Feature\FunctionalTestCase;
+use Portal\Transformers\SessionTransformer;
+use Portal\User;
+
+class SessionsControllerTest extends ApiTestCase
+{
+    public function setUp()
+    {
+        parent::setUp();
+
+        config(['session.driver' => 'database']);
+    }
+
+    public function test_unauthenticated()
+    {
+        $user = factory(User::class)->create();
+
+        $session = $this->createSession($user);
+
+        $this->getJson("/api/sessions/{$session->id}")
+            ->assertResponseStatus(401);
+    }
+
+    public function test_get_session_which_belongs_to_other_user()
+    {
+        $user = $this->login();
+        $user2 = factory(User::class)->create();
+
+        $session = $this->createSession($user2);
+
+        $this->getJson("/api/sessions/{$session->id}")
+            ->assertResponseStatus(403);
+    }
+
+    public function test_get_session()
+    {
+        $user = $this->login();
+
+        $session = $this->createSession($user);
+
+        $this->getJson("/api/sessions/{$session->id}")
+            ->seeStatusCode(200)
+            ->seeJson(
+                (new SessionTransformer)->transform($session)
+            );
+    }
+
+    public function test_invalidate_his_own_session()
+    {
+        $user = $this->login();
+
+        $session = $this->createSession($user);
+
+        $this->deleteJson("/api/sessions/{$session->id}")
+            ->seeStatusCode(200)
+            ->seeJson([
+                'success' => true
+            ]);
+    }
+
+    public function test_invalidate_session_for_other_user()
+    {
+        $user = $this->login();
+
+        $this->addPermissionForUser($user, 'users.manage');
+
+        $user2 = factory(User::class)->create();
+
+        $session = $this->createSession($user2);
+
+        $this->deleteJson("/api/sessions/{$session->id}")
+            ->seeStatusCode(200)
+            ->seeJson([
+                'success' => true
+            ]);
+    }
+
+    public function test_invalidate_session_for_other_user_without_permission()
+    {
+        $user = $this->login();
+
+        $user2 = factory(User::class)->create();
+
+        $session = $this->createSession($user2);
+
+        $this->deleteJson("/api/sessions/{$session->id}")
+            ->seeStatusCode(403);
+    }
+
+    private function createSession(User $user)
+    {
+        $sessionId = str_random(40);
+
+        $data = [
+            'id' => $sessionId,
+            'user_id' => $user->id,
+            'ip_address' => "127.0.0.1",
+            'user_agent' => 'foo',
+            'payload' => str_random(),
+            'last_activity' => Carbon::now()->timestamp
+        ];
+
+        \DB::table('sessions')->insert($data);
+
+        return (object) $data;
+    }
+}
diff --git a/tests/Feature/Http/Controllers/Api/SettingsControllerTest.php b/tests/Feature/Http/Controllers/Api/SettingsControllerTest.php
new file mode 100644
index 0000000..c629591
--- /dev/null
+++ b/tests/Feature/Http/Controllers/Api/SettingsControllerTest.php
@@ -0,0 +1,37 @@
+<?php
+
+namespace Tests\Feature\Http\Controllers\Api;
+
+use Settings;
+use Tests\Feature\ApiTestCase;
+use Portal\User;
+
+class SettingsControllerTest extends ApiTestCase
+{
+    public function test_unauthenticated()
+    {
+        $this->getJson('/api/settings')
+            ->assertResponseStatus(401);
+    }
+
+    public function test_get_settings_without_permission()
+    {
+        $user = factory(User::class)->create();
+
+        $this->actingAs($user, 'api')
+            ->getJson('/api/settings')
+            ->assertResponseStatus(403);
+    }
+
+    public function test_get_settings()
+    {
+        $user = $this->login();
+
+        $this->addPermissionForUser($user, 'settings.general');
+
+        $this->getJson("/api/settings");
+
+        $this->assertResponseOk()
+            ->seeJsonEquals(Settings::all());
+    }
+}
diff --git a/tests/Feature/Http/Controllers/Api/StatsControllerTest.php b/tests/Feature/Http/Controllers/Api/StatsControllerTest.php
new file mode 100644
index 0000000..6301f4b
--- /dev/null
+++ b/tests/Feature/Http/Controllers/Api/StatsControllerTest.php
@@ -0,0 +1,108 @@
+<?php
+
+namespace Tests\Feature\Http\Controllers\Api;
+
+use Carbon\Carbon;
+use Illuminate\Support\Collection;
+use Tests\Feature\ApiTestCase;
+use Tests\Feature\FunctionalTestCase;
+use Portal\Country;
+use Portal\Repositories\Activity\ActivityRepository;
+use Portal\Repositories\User\UserRepository;
+use Portal\Role;
+use Portal\Services\Logging\UserActivity\Activity;
+use Portal\Support\Enum\UserStatus;
+use Portal\Transformers\ActivityTransformer;
+use Portal\Transformers\RoleTransformer;
+use Portal\Transformers\SessionTransformer;
+use Portal\Transformers\UserTransformer;
+use Portal\User;
+
+class StatsControllerTest extends ApiTestCase
+{
+    public function test_unauthenticated()
+    {
+        $this->getJson('/api/stats')
+            ->assertResponseStatus(401);
+    }
+
+    public function test_get_stats_as_admin()
+    {
+        $adminRole = Role::whereName('Admin')->first();
+
+        $user = factory(User::class)->create([
+            'role_id' => $adminRole->id,
+        ]);
+
+        $this->be($user, 'api');
+
+        Carbon::setTestNow(Carbon::now()->startOfYear());
+
+        $activeUsers = factory(User::class)->times(4)->create([
+            'status' => UserStatus::ACTIVE
+        ]);
+
+        Carbon::setTestNow(null);
+
+        $bannedUsers = factory(User::class)->times(2)->create([
+            'status' => UserStatus::BANNED
+        ]);
+
+        $unconfirmedUsers = factory(User::class)->times(7)->create([
+            'status' => UserStatus::UNCONFIRMED
+        ]);
+
+        $users = app(UserRepository::class);
+
+        $this->getJson("/api/stats");
+
+        $usersPerMonth = $users->countOfNewUsersPerMonth(
+            Carbon::now()->startOfYear(),
+            Carbon::now()
+        );
+
+        $latestRegistrations = $users->latest(7);
+
+        $this->assertResponseOk()
+            ->seeJsonContains([
+                'users_per_month' => $usersPerMonth,
+                'users_per_status' => [
+                    'total' => 14,
+                    'new' => $users->newUsersCount(),
+                    'banned' => 2,
+                    'unconfirmed' => 7
+                ],
+                'latest_registrations' => $this->transformCollection($latestRegistrations, new UserTransformer)
+            ]);
+    }
+
+    public function test_get_stats_as_non_admin_user()
+    {
+        $user = factory(User::class)->create();
+
+        $this->be($user, 'api');
+
+        Carbon::setTestNow(Carbon::now()->subWeek());
+
+        factory(Activity::class)->times(5)->create([
+            'user_id' => $user->id
+        ]);
+
+        Carbon::setTestNow(null);
+
+        factory(Activity::class)->times(5)->create([
+            'user_id' => $user->id
+        ]);
+
+        $this->getJson("/api/stats");
+
+        $expected = app(ActivityRepository::class)->userActivityForPeriod(
+            $user->id,
+            Carbon::now()->subWeek(2),
+            Carbon::now()
+        )->toArray();
+
+        $this->assertResponseOk()
+            ->seeJsonEquals($expected);
+    }
+}
diff --git a/tests/Feature/Http/Controllers/Api/Users/ActivityControllerTest.php b/tests/Feature/Http/Controllers/Api/Users/ActivityControllerTest.php
new file mode 100644
index 0000000..f23e14f
--- /dev/null
+++ b/tests/Feature/Http/Controllers/Api/Users/ActivityControllerTest.php
@@ -0,0 +1,109 @@
+<?php
+
+namespace Tests\Feature\Http\Controllers\Api\Users;
+
+use Tests\Feature\ApiTestCase;
+use Portal\Services\Logging\UserActivity\Activity;
+use Portal\Transformers\ActivityTransformer;
+use Portal\User;
+
+class ActivityControllerTest extends ApiTestCase
+{
+    public function test_auth()
+    {
+        $user = factory(User::class)->create();
+
+        $this->getJson("/api/users/{$user->id}/activity")
+            ->assertResponseStatus(401);
+    }
+
+    public function test_cannot_view_user_activity_without_permission()
+    {
+        $user = factory(User::class)->create();
+
+        $this->actingAs($user, 'api')
+            ->getJson("/api/users/{$user->id}/activity")
+            ->assertResponseStatus(403);
+    }
+
+    public function test_paginate_activities_for_user()
+    {
+        $user = $this->login();
+
+        $this->addPermissionForUser($user, 'users.activity');
+
+        $activities = factory(Activity::class)->times(25)->create([
+            'user_id' => $user->id
+        ]);
+
+        $this->getJson("/api/users/{$user->id}/activity");
+
+        $transformed = $this->transformCollection(
+            $activities->take(20),
+            new ActivityTransformer
+        );
+
+        $response = $this->decodeResponseJson();
+
+        $this->assertEquals($response['data'], $transformed);
+        $this->assertEquals($response['meta'], [
+            'current_page' => 1,
+            'from' => 1,
+            'to' => 20,
+            'last_page' => 2,
+            'prev_page_url' => null,
+            'next_page_url' => url("api/users/{$user->id}/activity?page=2"),
+            'total' => 25,
+            'per_page' => 20
+        ]);
+    }
+
+    public function test_paginate_activities_for_user_with_search_param()
+    {
+        $user = $this->login();
+
+        $this->addPermissionForUser($user, 'users.activity');
+
+        $set1 = factory(Activity::class)->times(10)->create([
+            'user_id' => $user->id,
+            'description' => 'Lorem ipsum dolor sit amet, consectetur adipiscing elit.'
+        ]);
+
+        $set2 = factory(Activity::class)->times(5)->create([
+            'user_id' => $user->id,
+            'description' => 'Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris...'
+        ]);
+
+        $transformed = $this->transformCollection(
+            $set2,
+            new ActivityTransformer
+        );
+
+        $this->getJson("/api/users/{$user->id}/activity?search=minim&per_page=10");
+
+        $response = $this->decodeResponseJson();
+
+        $this->assertEquals($response['data'], $transformed);
+        $this->assertEquals($response['meta'], [
+            'current_page' => 1,
+            'from' => 1,
+            'to' => 5,
+            'last_page' => 1,
+            'prev_page_url' => null,
+            'next_page_url' => null,
+            'total' => 5,
+            'per_page' => 10
+        ]);
+    }
+
+    public function test_paginate_activities_for_user_with_more_activities_per_page_than_allowed()
+    {
+        $user = $this->login();
+
+        $this->addPermissionForUser($user, 'users.activity');
+
+        $this->getJson("/api/users/{$user->id}/activity?per_page=140");
+
+        $this->seeStatusCode(422);
+    }
+}
diff --git a/tests/Feature/Http/Controllers/Api/Users/AvatarControllerTest.php b/tests/Feature/Http/Controllers/Api/Users/AvatarControllerTest.php
new file mode 100644
index 0000000..a738a1e
--- /dev/null
+++ b/tests/Feature/Http/Controllers/Api/Users/AvatarControllerTest.php
@@ -0,0 +1,154 @@
+<?php
+
+namespace Tests\Feature\Http\Controllers\Api\Users;
+
+use Illuminate\Http\UploadedFile;
+use Tests\Feature\ApiTestCase;
+use Portal\Events\User\UpdatedByAdmin;
+use Portal\User;
+
+class AvatarControllerTest extends ApiTestCase
+{
+    public function test_upload_user_avatar_unauthenticated()
+    {
+        $user = factory(User::class)->create();
+
+        $server = $this->transformHeadersToServerVars([
+            'Accept' => 'application/json',
+            'Content-Type' => 'image/jpeg'
+        ]);
+
+        $this->call('PUT', "/api/users/{$user->id}/avatar", [], [], [], $server);
+
+        $this->assertResponseStatus(401);
+    }
+
+    public function test_upload_avatar_without_permission()
+    {
+        $user = factory(User::class)->create();
+
+        $server = $this->transformHeadersToServerVars([
+            'Accept' => 'application/json',
+            'Content-Type' => 'image/jpeg'
+        ]);
+
+        $this->actingAs($user, 'api')
+            ->call('PUT', "/api/users/{$user->id}/avatar", [], [], [], $server);
+
+        $this->assertResponseStatus(403);
+    }
+
+    public function test_upload_avatar_image()
+    {
+        $this->expectsEvents(UpdatedByAdmin::class);
+
+        $user = $this->login();
+
+        $this->addPermissionForUser($user, 'users.manage');
+
+        $file = UploadedFile::fake()->image('avatar.png', 500, 500);
+
+        $fileContent = file_get_contents($file->getRealPath());
+
+        $server = $this->transformHeadersToServerVars([
+            'Accept' => 'application/json',
+            'Content-Type' => 'image/jpeg'
+        ]);
+
+        $this->call('PUT', "/api/users/{$user->id}/avatar", [], [], [], $server, $fileContent);
+
+        $response = $this->decodeResponseJson();
+
+        $this->seeStatusCode(200)
+            ->assertNotNull($response['avatar']);
+
+        $uploadedFile = str_replace(url(''), '', $response['avatar']);
+        $uploadedFile = public_path(ltrim($uploadedFile, "/"));
+
+        $this->assertFileExists($uploadedFile);
+
+        list($width, $height) = getimagesize($uploadedFile);
+
+        $this->assertEquals(160, $width);
+        $this->assertEquals(160, $height);
+
+        @unlink($uploadedFile);
+    }
+
+    public function test_upload_invalid_image()
+    {
+        $user = $this->login();
+
+        $this->addPermissionForUser($user, 'users.manage');
+
+        $file = UploadedFile::fake()->create('avatar.png', 500);
+
+        $fileContent = file_get_contents($file->getRealPath());
+
+        $server = $this->transformHeadersToServerVars([
+            'Accept' => 'application/json',
+            'Content-Type' => 'image/jpeg'
+        ]);
+
+        $this->call('PUT', "/api/users/{$user->id}/avatar", [], [], [], $server, $fileContent);
+
+        $this->seeStatusCode(422)
+            ->seeJsonContains([
+                'file' => [
+                    trans('validation.image', ['attribute' => 'file'])
+                ]
+            ]);
+    }
+
+    public function test_update_avatar_from_external_source()
+    {
+        $this->expectsEvents(UpdatedByAdmin::class);
+
+        $user = $this->login();
+
+        $this->addPermissionForUser($user, 'users.manage');
+
+        $url = 'http://google.com';
+
+        $this->putJson("/api/users/{$user->id}/avatar/external", [
+            'url' => $url
+        ]);
+
+        $this->assertResponseOk();
+        $this->seeJsonContains([
+            'avatar' => $url
+        ]);
+    }
+
+    public function test_update_avatar_with_invalid_external_source()
+    {
+        $user = $this->login();
+
+        $this->addPermissionForUser($user, 'users.manage');
+
+        $this->putJson("/api/users/{$user->id}/avatar/external", [
+            'url' => 'foo'
+        ]);
+
+        $this->assertResponseStatus(422);
+    }
+
+    public function test_delete_user_avatar()
+    {
+        $this->expectsEvents(UpdatedByAdmin::class);
+
+        $user = $this->login();
+
+        $this->addPermissionForUser($user, 'users.manage');
+
+        $user->forceFill([
+            'avatar' => 'http://google.com'
+        ])->save();
+
+        $this->deleteJson("api/users/{$user->id}/avatar")
+            ->assertResponseOk()
+            ->seeJsonContains([
+                'avatar' => url('assets/img/profile.png') // default profile image
+            ]);
+    }
+}
diff --git a/tests/Feature/Http/Controllers/Api/Users/SessionsControllerTest.php b/tests/Feature/Http/Controllers/Api/Users/SessionsControllerTest.php
new file mode 100644
index 0000000..cd9b934
--- /dev/null
+++ b/tests/Feature/Http/Controllers/Api/Users/SessionsControllerTest.php
@@ -0,0 +1,66 @@
+<?php
+
+namespace Tests\Feature\Http\Controllers\Api\Users;
+
+use Tests\Feature\ApiTestCase;
+use Portal\Transformers\SessionTransformer;
+use Portal\User;
+
+class SessionsControllerTest extends ApiTestCase
+{
+    public function test_get_sessions_unauthenticated()
+    {
+        $user = factory(User::class)->create();
+
+        $this->getJson("/api/users/{$user->id}/sessions")
+            ->seeStatusCode(401);
+    }
+
+    public function test_get_user_sessions_without_permission()
+    {
+        $user = factory(User::class)->create();
+
+        $this->actingAs($user, 'api')
+            ->getJson("/api/users/{$user->id}/sessions")
+            ->seeStatusCode(403);
+    }
+
+    public function test_get_user_sessions()
+    {
+        $user = $this->login();
+
+        $this->addPermissionForUser($user, 'users.manage');
+
+        $sessions = $this->generateNonExpiredSessions($user);
+
+        $this->getJson("/api/users/{$user->id}/sessions")
+            ->seeStatusCode(200)
+            ->seeJson(
+                $this->transformCollection($sessions, new SessionTransformer)
+            );
+    }
+
+    private function generateNonExpiredSessions(User $user, $count = 5)
+    {
+        $sessions = [];
+        $faker = $this->app->make(\Faker\Generator::class);
+        $lifetime = config('session.lifetime') - 1;
+
+        for ($i = 0; $i < $count; $i++) {
+            array_push($sessions, [
+                'id' => str_random(40),
+                'user_id' => $user->id,
+                'ip_address' => $faker->ipv4,
+                'user_agent' => $faker->userAgent,
+                'payload' => str_random(),
+                'last_activity' => $faker->dateTimeBetween("-{$lifetime} minutes")->getTimestamp()
+            ]);
+        }
+
+        \DB::table('sessions')->insert($sessions);
+
+        return \DB::table('sessions')
+            ->where('user_id', $user->id)
+            ->get();
+    }
+}
diff --git a/tests/Feature/Http/Controllers/Api/Users/TwoFactorControllerTest.php b/tests/Feature/Http/Controllers/Api/Users/TwoFactorControllerTest.php
new file mode 100644
index 0000000..64353bf
--- /dev/null
+++ b/tests/Feature/Http/Controllers/Api/Users/TwoFactorControllerTest.php
@@ -0,0 +1,125 @@
+<?php
+
+namespace Tests\Feature\Http\Controllers\Api\Users;
+
+use Authy;
+use Settings;
+use Tests\Feature\ApiTestCase;
+use Portal\Events\User\TwoFactorDisabledByAdmin;
+use Portal\Events\User\TwoFactorEnabledByAdmin;
+use Portal\Transformers\UserTransformer;
+use Portal\User;
+
+class TwoFactorControllerTest extends ApiTestCase
+{
+    public function test_update_2fa_unathenticated()
+    {
+        $user = factory(User::class)->create();
+
+        $this->putJson("api/users/{$user->id}/2fa")
+            ->assertResponseStatus(401);
+    }
+
+    public function test_update_2fa_without_permission()
+    {
+        $user = factory(User::class)->create();
+
+        $this->actingAs($user, 'api')
+            ->putJson("api/users/{$user->id}/2fa")
+            ->assertResponseStatus(403);
+    }
+
+    public function test_enable_two_factor_auth_for_user()
+    {
+        $this->expectsEvents(TwoFactorEnabledByAdmin::class);
+
+        $user = $this->login();
+
+        $this->addPermissionForUser($user, 'users.manage');
+
+        Settings::set('2fa.enabled', true);
+
+        Authy::shouldReceive('isEnabled')->andReturn(false);
+        Authy::shouldReceive('register')->andReturnNull();
+
+        $data = ['country_code' => '1', 'phone_number' => '123'];
+ 
+        $this->putJson("api/users/{$user->id}/2fa", $data);
+
+        $transformer = new UserTransformer;
+        $updatedUser = $transformer->transform($user->fresh());
+
+        $this->assertResponseOk()
+            ->seeInDatabase('users', [
+                'id' => $user->id,
+                'two_factor_country_code' => $data['country_code'],
+                'two_factor_phone' => $data['phone_number']
+            ])
+            ->seeJsonContains($updatedUser);
+    }
+
+    public function test_enable_two_factor_auth_for_user_when_it_is_already_enabled()
+    {
+        $user = $this->login();
+
+        $this->addPermissionForUser($user, 'users.manage');
+
+        Settings::set('2fa.enabled', true);
+
+        Authy::shouldReceive('isEnabled')->andReturn(true);
+
+        $data = ['country_code' => '1', 'phone_number' => '123'];
+
+        $this->putJson("api/users/{$user->id}/2fa", $data);
+
+        $this->assertResponseStatus(422)
+            ->seeJsonContains([
+                'error' => '2FA is already enabled for this user.'
+            ]);
+    }
+
+    public function test_disable_two_factor_auth_for_user()
+    {
+        $this->expectsEvents(TwoFactorDisabledByAdmin::class);
+
+        $user = factory(User::class)->create([
+            'two_factor_country_code' => '1',
+            'two_factor_phone' => '123'
+        ]);
+
+        $this->addPermissionForUser($user, 'users.manage');
+
+        $this->be($user, 'api');
+
+        Settings::set('2fa.enabled', true);
+
+        Authy::shouldReceive('isEnabled')->andReturn(true);
+        Authy::shouldReceive('delete')->andReturnNull();
+
+        $this->deleteJson("api/users/{$user->id}/2fa");
+
+        $transformer = new UserTransformer;
+        $user = $transformer->transform($user->fresh());
+
+        $this->assertResponseOk()
+            ->seeJsonContains($user);
+    }
+
+    public function test_disable_2fa_for_user_when_it_is_already_disabled()
+    {
+        $user = $this->login();
+
+        $this->addPermissionForUser($user, 'users.manage');
+
+        Settings::set('2fa.enabled', true);
+
+        Authy::shouldReceive('isEnabled')->andReturn(false);
+
+        $this->deleteJson("api/users/{$user->id}/2fa");
+
+        $this->assertResponseStatus(422)
+            ->seeJsonContains([
+                'error' => '2FA is not enabled for this user.'
+            ]);
+    }
+}
